/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20190509 (64-bit version)
 * Copyright (c) 2000 - 2019 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt4.dat, Sun Jan 26 18:45:00 2020
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x00001C20 (7200)
 *     Revision         0x01
 *     Checksum         0x58
 *     OEM ID           "AMD"
 *     OEM Table ID     "CPMD3CLD"
 *     OEM Revision     0x00000001 (1)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20120913 (538052883)
 */
DefinitionBlock ("", "SSDT", 1, "AMD", "CPMD3CLD", 0x00000001)
{
    /*
     * iASL Warning: There were 22 external control methods found during
     * disassembly, but only 0 were resolved (22 unresolved). Additional
     * ACPI tables may be required to properly disassemble the code. This
     * resulting disassembler output file may not compile because the
     * disassembler did not know how many arguments to assign to the
     * unresolved methods. Note: SSDTs can be dynamically loaded at
     * runtime and may or may not be available via the host OS.
     *
     * To specify the tables needed to resolve external control method
     * references, the -e option can be used to specify the filenames.
     * Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (_SB_.AGRB, UnknownObj)
    External (_SB_.ALIB, IntObj)
    External (_SB_.MACO, UnknownObj)
    External (_SB_.PCI0.GPP0, DeviceObj)
    External (_SB_.PCI0.GPP0._ADR, UnknownObj)
    External (_SB_.PCI0.GPP0.HDAU._ADR, UnknownObj)
    External (_SB_.PCI0.GPP0.SWUS, DeviceObj)
    External (_SB_.PCI0.GPP0.SWUS.SWDS, DeviceObj)
    External (_SB_.PCI0.GPP0.VGA_._ADR, UnknownObj)
    External (_SB_.PCI0.SBRG.EC0_.ECDT, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (_SB_.PCI0.SBRG.EC0_.ECUT, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (_SB_.PCI0.SBRG.EC0_.WVDC, MethodObj)    // Warning: Unknown method, guessing 0 arguments
    External (M000, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (M009, UnknownObj)
    External (M010, MethodObj)    // Warning: Unknown method, guessing 2 arguments
    External (M013, MethodObj)    // Warning: Unknown method, guessing 7 arguments
    External (M014, MethodObj)    // Warning: Unknown method, guessing 5 arguments
    External (M017, MethodObj)    // Warning: Unknown method, guessing 5 arguments
    External (M018, MethodObj)    // Warning: Unknown method, guessing 7 arguments
    External (M019, MethodObj)    // Warning: Unknown method, guessing 3 arguments
    External (M020, MethodObj)    // Warning: Unknown method, guessing 5 arguments
    External (M021, MethodObj)    // Warning: Unknown method, guessing 3 arguments
    External (M023, MethodObj)    // Warning: Unknown method, guessing 3 arguments
    External (M024, MethodObj)    // Warning: Unknown method, guessing 2 arguments
    External (M025, MethodObj)    // Warning: Unknown method, guessing 2 arguments
    External (M026, MethodObj)    // Warning: Unknown method, guessing 3 arguments
    External (M027, MethodObj)    // Warning: Unknown method, guessing 7 arguments
    External (M028, MethodObj)    // Warning: Unknown method, guessing 4 arguments
    External (M049, IntObj)
    External (M084, UnknownObj)
    External (M085, UnknownObj)
    External (M097, MethodObj)    // Warning: Unknown method, guessing 2 arguments
    External (M106, IntObj)
    External (M111, MethodObj)    // Warning: Unknown method, guessing 2 arguments
    External (M112, MethodObj)    // Warning: Unknown method, guessing 2 arguments
    External (M113, IntObj)
    External (M128, UnknownObj)
    External (M133, UnknownObj)
    External (M232, MethodObj)    // Warning: Unknown method, guessing 3 arguments
    External (M275, UnknownObj)
    External (M378, IntObj)
    External (M379, IntObj)
    External (M380, IntObj)
    External (M381, IntObj)
    External (M382, IntObj)
    External (M383, IntObj)
    External (M384, IntObj)
    External (M385, IntObj)
    External (M386, IntObj)
    External (M387, IntObj)
    External (M388, IntObj)
    External (M389, IntObj)
    External (M390, IntObj)
    External (M391, IntObj)
    External (M392, IntObj)
    External (PGST, UnknownObj)

    Scope (\)
    {
        Name (REST, 0x8C)
        Name (PWEN, 0x06)
        Name (PWOK, 0x8D)
    }

    Scope (\_SB.PCI0.GPP0)
    {
        Name (M236, Buffer (0x0C)
        {
            /* 0000 */  0x24, 0x01, 0x01, 0x01, 0x00, 0x00, 0x00, 0x00,  // $.......
            /* 0008 */  0x00, 0x00, 0x00, 0x00                           // ....
        })
        Name (M266, Zero)
        Name (M267, Zero)
        Name (M268, Zero)
        Name (M269, Zero)
        Name (M270, Zero)
        Name (M271, Zero)
        Name (M350, Buffer (0x18)
        {
            /* 0000 */  0x07, 0x00, 0x10, 0x00, 0x00, 0x01, 0x01, 0x00,  // ........
            /* 0008 */  0x00, 0xF6, 0x00, 0xF7, 0x01, 0xC0, 0xF1, 0xD1,  // ........
            /* 0010 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00   // ........
        })
        Name (M351, Buffer (0x18)
        {
            /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
            /* 0008 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
            /* 0010 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00   // ........
        })
        Name (M352, Buffer (0x18)
        {
            /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
            /* 0008 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
            /* 0010 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00   // ........
        })
        Name (M353, Buffer (0x18)
        {
            /* 0000 */  0x00, 0x00, 0x10, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
            /* 0008 */  0x0C, 0x00, 0x00, 0xD0, 0x01, 0xF0, 0x00, 0x00,  // ........
            /* 0010 */  0xDE, 0x10, 0x91, 0x1C, 0x00, 0x00, 0x00, 0x00   // ........
        })
        Name (M354, Buffer (0x18)
        {
            /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
            /* 0008 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
            /* 0010 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00   // ........
        })
        Name (M355, Buffer (0x18)
        {
            /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
            /* 0008 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
            /* 0010 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00   // ........
        })
        Name (M356, Buffer (0x18)
        {
            /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
            /* 0008 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
            /* 0010 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00   // ........
        })
        Name (M357, Buffer (0x18)
        {
            /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
            /* 0008 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
            /* 0010 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00   // ........
        })
        Name (M358, Buffer (0x18)
        {
            /* 0000 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
            /* 0008 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
            /* 0010 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00   // ........
        })
        Method (M371, 5, NotSerialized)
        {
            CreateDWordField (Arg3, Zero, M365)
            CreateDWordField (Arg3, 0x04, M366)
            CreateDWordField (Arg3, 0x08, M367)
            CreateDWordField (Arg3, 0x0C, M368)
            CreateDWordField (Arg3, 0x10, M369)
            CreateDWordField (Arg3, 0x14, M370)
            If ((Arg4 < 0x02))
            {
                If ((Arg4 == Zero))
                {
                    0x04 = M019 (Arg0, Arg1, Arg2)
                    M365
                    0x18 = M019 (Arg0, Arg1, Arg2)
                    M366
                    0x20 = M019 (Arg0, Arg1, Arg2)
                    M367
                    0x24 = M019 (Arg0, Arg1, Arg2)
                    M368
                    0x28 = M019 (Arg0, Arg1, Arg2)
                    M369
                    0x2C = M019 (Arg0, Arg1, Arg2)
                    M370
                }
                Else
                {
                    0x04 = M019 (Arg0, Arg1, Arg2)
                    M365
                    0x18 = M019 (Arg0, Arg1, Arg2)
                    M366
                    0x1C = M019 (Arg0, Arg1, Arg2)
                    M367
                    0x24 = M019 (Arg0, Arg1, Arg2)
                    M368
                     = M019 (Arg0, Arg1, Arg2)
                    M369
                    M370 = Arg0
                }
            }
            Else
            {
                If (((Arg4 & One) == Zero))
                {
                    M020 (Arg0, Arg1, Arg2, 0x18, M366)
                    M020 (Arg0, Arg1, Arg2, 0x20, M367)
                    M020 (Arg0, Arg1, Arg2, 0x24, M368)
                    M020 (Arg0, Arg1, Arg2, 0x28, M369)
                    M020 (Arg0, Arg1, Arg2, 0x2C, M370)
                }
                Else
                {
                    M020 (Arg0, Arg1, Arg2, 0x18, M366)
                    M020 (Arg0, Arg1, Arg2, 0x1C, M367)
                    M020 (Arg0, Arg1, Arg2, 0x24, M368)
                }

                If (((Arg4 & 0x04) == 0x04))
                {
                    M020 (Arg0, Arg1, Arg2, 0x04, (M365 & 0x06FFFFFF))
                }
                Else
                {
                    0x04 = M019 (Arg0, Arg1, Arg2)
                    Local0
                    M020 (Arg0, Arg1, Arg2, 0x04, ((Local0 & 0x06FFFFF8) | 0x02))
                }
            }
        }

        Method (M372, 0, NotSerialized)
        {
            CreateDWordField (M353, 0x10, M362)
            Local0 = Zero
            If (((M362 & 0xFFDF) == 0x1002))
            {
                Local1 = (M362 >> 0x10)
                Local1 &= 0xFFFF
                If (((Local1 >= 0x67C0) && (Local1 <= 0x67DF)))
                {
                    Local0 = 0x10
                }
                ElseIf (((Local1 >= 0x67E0) && (Local1 <= 0x67FF)))
                {
                    Local0 = 0x11
                }
                ElseIf (((Local1 >= 0x6900) && (Local1 <= 0x695F)))
                {
                    Local0 = 0x12
                }
                ElseIf (((Local1 >= 0x6980) && (Local1 <= 0x699F)))
                {
                    Local0 = 0x13
                }
                ElseIf (((Local1 >= 0x6860) && (Local1 <= 0x687F)))
                {
                    Local0 = 0x20
                }
                ElseIf (((Local1 >= 0x69A0) && (Local1 <= 0x69BF)))
                {
                    Local0 = 0x21
                }
                Else
                {
                    Local0 = Zero
                }
            }
            ElseIf (((M362 & 0xFFFF) == 0x10DE))
            {
                Local0 = 0xC0
            }

            Return (Local0)
        }

        Method (M373, 3, NotSerialized)
        {
            CreateDWordField (M350, 0x04, M359)
            CreateDWordField (M351, 0x04, M360)
            CreateDWordField (M352, 0x04, M361)
            M354 = M358 /* \_SB_.PCI0.GPP0.M358 */
            M355 = M358 /* \_SB_.PCI0.GPP0.M358 */
            M356 = M358 /* \_SB_.PCI0.GPP0.M358 */
            M357 = M358 /* \_SB_.PCI0.GPP0.M358 */
            M371 (Arg0, Arg1, Arg2, M354, Zero)
            M020 (Arg0, Arg1, Arg2, 0x18, M359)
            Local0 = (M359 >> 0x08)
            Local0 &= 0xFF
            If ((M360 != Zero))
            {
                M371 (Local0, Zero, Zero, M355, Zero)
                M020 (Local0, Zero, Zero, 0x18, M360)
                Local0 = (M360 >> 0x08)
                Local0 &= 0xFF
            }

            If (((M360 != Zero) && (M361 != Zero)))
            {
                M371 (Local0, Zero, Zero, M356, Zero)
                M020 (Local0, Zero, Zero, 0x18, M361)
                Local0 = (M361 >> 0x08)
                Local0 &= 0xFF
            }

            M371 (Local0, Zero, Zero, M357, One)
        }

        Method (M374, 3, NotSerialized)
        {
            CreateDWordField (M350, 0x04, M359)
            CreateDWordField (M351, 0x04, M360)
            CreateDWordField (M352, 0x04, M361)
            M371 (Arg0, Arg1, Arg2, M350, 0x02)
            Local0 = (M359 >> 0x08)
            Local0 &= 0xFF
            If ((M360 != Zero))
            {
                M371 (Local0, Zero, Zero, M351, 0x02)
                Local0 = (M360 >> 0x08)
                Local0 &= 0xFF
            }

            If (((M360 != Zero) && (M361 != Zero)))
            {
                M371 (Local0, Zero, Zero, M352, 0x02)
                Local0 = (M361 >> 0x08)
                Local0 &= 0xFF
            }

            M371 (Local0, Zero, Zero, M353, 0x03)
        }

        Method (M375, 0, Serialized)
        {
            CreateQWordField (M353, 0x04, M363)
            CreateDWordField (M353, 0x0C, M364)
            Local0 = M372 ()
            If (((Local0 >= Zero) && (Local0 <= 0x0F)))
            {
                M232 (M097 (Zero, 0x10), ElseIf (((Local0 >= 0x10) && 
                    (Local0 <= 0x1F)))
                    {
                        Store (M013 ((M364 & 0xFFFFFFF0), 0x5418, Zero, 0x20, Local2, M014 ((
                            M364 & 0xFFFFFFF0), 0x5418, Zero, 0x20, (Local2 & 0xFFFFFFFD)), ElseIf ((
                            (Local0 >= 0x20) && (Local0 <= 0xBF)))
                                {
                                    Store (M013 ((M364 & 0xFFFFFFF0), 0x34E0, Zero, 0x20, Local2, M014 ((
                                        M364 & 0xFFFFFFF0), 0x34E0, Zero, 0x20, (Local2 & 0xEFFFFFFF)))
                                })
                    })
            }
        }

        Method (M376, 0, Serialized)
        {
            CreateByteField (M236, 0x03, M245)
            CreateDWordField (M236, 0x04, M246)
            CreateDWordField (M236, 0x08, M247)
            Local0 = M372 ()
            If (((Local0 >= Zero) && (Local0 <= 0xBF)))
            {
                Local2 = 0x7FFFFFFF
                Local2 |= 0x80000000
                M020 (M245, Zero, Zero, 0x4C, M246)
                 = M019 (M245, Zero, One)
                Local1
                If (((Local1 != Local2) && (M247 != Local2)))
                {
                    M020 (M245, Zero, One, 0x4C, M247)
                }
            }
        }

        Method (M377, 3, NotSerialized)
        {
            CreateByteField (M236, 0x03, M245)
            CreateDWordField (M350, 0x04, M359)
            CreateDWordField (M351, 0x04, M360)
            CreateDWordField (M352, 0x04, M361)
            M371 (M245, Zero, Zero, M357, 0x05)
            If (((M360 != Zero) && (M361 != Zero)))
            {
                Local0 = (M360 >> 0x08)
                Local0 &= 0xFF
                M371 (Local0, Zero, Zero, M356, 0x04)
            }

            If ((M360 != Zero))
            {
                Local0 = (M359 >> 0x08)
                Local0 &= 0xFF
                M371 (Local0, Zero, Zero, M355, 0x04)
            }

            M371 (Arg0, Arg1, Arg2, M354, 0x04)
        }

        Mutex (EEBC, 0x00)
        Method (M241, 1, NotSerialized)
        {
            Acquire (EEBC, 0xFFFF)
            CreateByteField (M236, Zero, M242)
            CreateByteField (M236, One, M243)
            CreateByteField (M236, 0x02, M244)
            CreateByteField (M236, 0x03, M245)
            CreateDWordField (M236, 0x04, M246)
            CreateDWordField (M236, 0x08, M247)
            Name (M272, Zero)
            Name (M273, Zero)
            Name (M274, Zero)
            ((0x65 = (M049 >> M128)) /* External reference */ & 0x05)
            One
            M273
            ((0x65 = (M049 >> M128)) /* External reference */ & 0x06)
            One
            M274
            If ((M273 != One))
            {
                Local7 = Buffer (0x05){}
                CreateWordField (Local7, Zero, M197)
                CreateField (Local7, 0x10, 0x03, M200)
                CreateField (Local7, 0x13, 0x05, M199)
                CreateByteField (Local7, 0x03, M198)
                CreateByteField (Local7, 0x04, M201)
                M197 = 0x05
                M198 = Zero
                Local0 = M243 /* \_SB_.PCI0.GPP0.M241.M243 */
                M199 = Local0
                Local0 = M244 /* \_SB_.PCI0.GPP0.M241.M244 */
                M200 = Local0
            }

            If ((M085 >= 0x09))
            {
                Local3 = Buffer (0x08){}
                CreateWordField (Local3, Zero, M254)
                CreateByteField (Local3, 0x02, M255)
                CreateDWordField (Local3, 0x03, M256)
                M254 = 0x07
                M255 = 0x10
            }

            M133 = M049 /* External reference */
            0x01D4
            M266
            M133 = M049 /* External reference */
            0x01D5
            M267
            M133 = M049 /* External reference */
            0x01D6
            M268
            M133 = M049 /* External reference */
            0x01D7
            M269
            M133 = M049 /* External reference */
            0x01D8
            M270
            M133 = M049 /* External reference */
            0x01D9
            M271
            Local0 = ((M084 + 0x1502) + (M266 * 0x04))
            OperationRegion (VAMM, SystemMemory, Local0, One)
            Field (VAMM, ByteAcc, NoLock, Preserve)
            {
                P011,   8
            }

            Local0 = ((M084 + 0x1502) + (M267 * 0x04))
            OperationRegion (VANN, SystemMemory, Local0, One)
            Field (VANN, ByteAcc, NoLock, Preserve)
            {
                P141,   8
            }

            If ((M274 == One))
            {
                Local6 = One
            }
            Else
            {
                M242 = M113 /* External reference */
                Local6
            }

            M023 (Zero, M243, M244)
            If ((M275 == M242))
            {
                Arg0
                Zero
                If ((Arg0 && Local6))
                {
                    M000 (0x9D)
                    If ((\_SB.MACO == One))
                    {
                        P141 = 0xC4
                        Sleep (M270)
                        M112 (M242, One)
                        Sleep (M271)
                        P011 = 0x84
                        \_SB.MACO = Zero
                    }
                    Else
                    {
                        M112 (M242, Zero)
                        M111 (M242, One)
                        Sleep (0x20)
                        M112 (M242, 0x02)
                        M112 (M242, One)
                        Sleep (0x64)
                    }

                    M000 (0x9E)
                    M272 = One
                    If ((M273 == One))
                    {
                        0x08 = M017 (Zero, M243, M244, 0x68, Zero)
                        Local1
                        M018 (Zero, M243, M244, 0x68, Zero, 0x08, (Local1 & 0xEF))
                        Sleep (0x18)
                        M244 = M025 (Zero, M243)
                        Local1
                        Local1 = Zero
                        While (((Local1 & 0x28) != 0x20))
                        {
                            M000 (0xC0)
                            0x08 = M017 (Zero, M243, M244, 0x6B, Zero)
                            Local1
                        }
                    }
                    Else
                    {
                        Sleep (0x14)
                        M201 = One
                        0x06 = \_SB.ALIB /* External reference */
                        Local7
                        Local6
                        If ((M085 < 0x08))
                        {
                            M272 = Zero
                            Local2 = Zero
                            While ((Local2 < 0x0F))
                            {
                                M023 (Zero, M243, M244)
                                Local4 = One
                                Local5 = 0xC8
                                While ((Local4 && Local5))
                                {
                                    0xA5 = M021 (Zero, M243, M244)
                                    Local0
                                    Local0 &= 0x7F
                                    If (((Local0 >= 0x10) && (Local0 != 0x7F)))
                                    {
                                        Local4 = Zero
                                    }
                                    Else
                                    {
                                        Sleep (0x05)
                                        Local5--
                                    }
                                }

                                If (!Local4)
                                {
                                    M244 = M024 (Zero, M243)
                                    Local5
                                    If (Local5)
                                    {
                                        M026 (Zero, M243, M244)
                                        Sleep (0x05)
                                        Local2++
                                    }
                                    Else
                                    {
                                        Local0 = Zero
                                        If ((M025 (Zero, M243) == M244))
                                        {
                                            Ones
                                            Local0 = One
                                        }

                                        If (Local0)
                                        {
                                            M272 = One
                                            Local2 = 0x10
                                        }
                                        Else
                                        {
                                            M272 = Zero
                                            Local2 = 0x10
                                        }
                                    }
                                }
                                Else
                                {
                                    Local2 = 0x10
                                }
                            }

                            If (!M272)
                            {
                                M000 (0x9F)
                                 = M019 (M245, Zero, Zero)
                                Local1
                                Sleep (0x0A)
                                Local4 = One
                                Local5 = 0x05
                                While ((Local4 && Local5))
                                {
                                    0xA5 = M021 (Zero, M243, M244)
                                    Local0
                                    Local0 &= 0x7F
                                    If (((Local0 <= 0x04) || (Local0 == 0x1F)))
                                    {
                                        Local4 = Zero
                                    }
                                    Else
                                    {
                                         = M019 (M245, Zero, Zero)
                                        Local0
                                        Sleep (0x05)
                                        Local5--
                                    }
                                }

                                M201 = Zero
                                \_SB.ALIB
                                0x06
                                Local7
                            }
                        }
                    }

                    M000 (0xC1)
                    If ((M272 == One))
                    {
                        Local6 = 0x7FFFFFFF
                        Local6 |= 0x80000000
                        0x54 = M019 (Zero, M243, M244)
                        Local1
                        M020 (Zero, M243, M244, 0x54, (Local1 & 0xFFFF7FFC))
                        0x08 = M017 (Zero, M243, M244, 0x19, Zero)
                        Local2
                        Local4 = One
                        Local5 = 0x28
                        While ((Local4 && Local5))
                        {
                             = M019 (Local2, Zero, Zero)
                            Local0
                            If ((Local0 != Local6))
                            {
                                Local0 = M372 ()
                                If (((Local0 >= Zero) && (Local0 <= 0xBF)))
                                {
                                    M373 (Zero, M243, M244)
                                    M374 (Zero, M243, M244)
                                    If ((M097 (Zero, M375 ()) != M376 ())){}
                                    M377 (Zero, M243, M244)
                                }

                                Local4 = Zero
                            }
                            Else
                            {
                                Sleep (0x19)
                                Local5--
                            }
                        }

                        M020 (Zero, M243, M244, 0x54, (Local1 & 0xFFFF7FFF))
                    }

                    If ((M085 >= 0x09))
                    {
                        Local0 = M372 ()
                        If (((Local0 >= Zero) && (Local0 <= 0xBF)))
                        {
                            M256 = One
                            \_SB.ALIB
                            0x0C
                            Local3
                        }
                    }

                    M000 (0xA0)
                }
                Else
                {
                    M000 (0xA1)
                    If ((M085 >= 0x09))
                    {
                        Local0 = M372 ()
                        If (((Local0 >= Zero) && (Local0 <= 0xBF)))
                        {
                            M256 = Zero
                            \_SB.ALIB
                            0x0C
                            Local3
                        }
                    }

                    If ((M273 == One))
                    {
                        0x54 = M019 (Zero, M243, M244)
                        Local1
                        M020 (Zero, M243, M244, 0x54, (Local1 & 0xFFFF7FFC))
                        Sleep (One)
                        0x08 = M017 (Zero, M243, M244, 0x19, Zero)
                        Local2
                        M028 (Local2, Zero, Zero, Zero)
                        M018 (Zero, M243, M244, 0x68, Zero, 0x08, (Local1 | 0x10)) = 
                            M027 (Local2, Zero, Zero, Local3, M020 (Zero, M243, M244, 0x54, (Local1 & 0xFFFF7FFF
                            )), 0x08 = M017 (Zero, M243, M244, 0x68, Zero), Local1)
                        Sleep (0x18)
                    }
                    Else
                    {
                        0x54 = M019 (Zero, M243, M244)
                        Local1
                        M020 (Zero, M243, M244, 0x54, (Local1 & 0xFFFF7FFC))
                        M201 = Zero
                        \_SB.ALIB
                        0x06
                        Local7
                        M020 (Zero, M243, M244, 0x54, (Local1 & 0xFFFF7FFF))
                    }

                    M000 (0xA2)
                    If ((\_SB.MACO == One))
                    {
                        P011 = 0xC4
                        Stall (M268)
                        P141 = 0x84
                        Sleep (M269)
                        M112 (M242, Zero)
                    }
                    Else
                    {
                        M112 (M242, Zero)
                        Sleep (0x0A)
                        M111 (M242, Zero)
                    }

                    M023 (Zero, M243, M244)
                     = M019 (M245, Zero, Zero)
                    Local1
                    Sleep (0x0A)
                    If ((M085 < 0x08))
                    {
                        Local4 = One
                        Local5 = 0x05
                        While ((Local4 && Local5))
                        {
                            0xA5 = M021 (Zero, M243, M244)
                            Local0
                            Local0 &= 0x7F
                            If (((Local0 <= 0x04) || (Local0 == 0x1F)))
                            {
                                Local4 = Zero
                            }
                            Else
                            {
                                 = M019 (M245, Zero, Zero)
                                Local1
                                Sleep (0x05)
                                Local5--
                            }
                        }
                    }

                    M000 (0xA3)
                    M272 = 0x02
                }
            }

            Release (EEBC)
        }

        PowerResource (PG00, 0x00, 0x0000)
        {
            Name (M239, One)
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                Return (M239) /* \_SB_.PCI0.GPP0.PG00.M239 */
            }

            Method (_ON, 0, NotSerialized)  // _ON_: Power On
            {
                If ((M239 == Zero))
                {
                    SGPC (One)
                    \_SB.PCI0.GPP0.CMDR = 0x07
                    \_SB.PCI0.GPP0.D0ST = Zero
                }

                M239 = One
                PGST = One
                \_SB.PCI0.SBRG.EC0.ECDT (\_SB.PCI0.SBRG.EC0.WVDC ())
            }

            Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
            {
                If ((M239 == One))
                {
                    SGPC (Zero)
                }

                M239 = Zero
                PGST = Zero
                \_SB.PCI0.SBRG.EC0.ECUT (\_SB.PCI0.SBRG.EC0.WVDC ())
            }
        }

        Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
        {
            PG00
        })
        Name (_PR2, Package (0x01)  // _PR2: Power Resources for D2
        {
            PG00
        })
        Name (_PR3, Package (0x01)  // _PR3: Power Resources for D3hot
        {
            PG00
        })
        Name (_S0W, 0x04)  // _S0W: S0 Device Wake State
        OperationRegion (RPCX, SystemMemory, ((\_SB.AGRB + (((\_SB.PCI0.GPP0._ADR & 0x00FF0000) >> 0x10) << 
            0x0F)) + ((\_SB.PCI0.GPP0._ADR & 0xFF) << 0x0C)), 0x1000)
        Field (RPCX, DWordAcc, NoLock, Preserve)
        {
            Offset (0x04), 
            CMDR,   8, 
            Offset (0x19), 
            PRBN,   8, 
            Offset (0x54), 
            D0ST,   2, 
            Offset (0x62), 
            CEDR,   1, 
            Offset (0x68), 
            ASPM,   2, 
                ,   2, 
            LNKD,   1, 
            Offset (0x80), 
                ,   10, 
            LREN,   1
        }

        Device (PEGP)
        {
            OperationRegion (PCIS, PCI_Config, Zero, 0x0100)
            Field (PCIS, AnyAcc, NoLock, Preserve)
            {
                PVID,   16, 
                PDID,   16
            }

            Name (_ADR, Zero)  // _ADR: Address
            Name (LTRE, Zero)
            Name (DGPS, Zero)
            Name (_PSC, Zero)  // _PSC: Power State Current
            Name (GPRF, Zero)
            Name (OPCE, 0x02)
            Method (_INI, 0, NotSerialized)  // _INI: Initialize
            {
                \_SB.PCI0.GPP0.VGA._ADR = 0xFF
                \_SB.PCI0.GPP0.HDAU._ADR = 0xFE
            }

            Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
            {
                Return (Zero)
            }

            OperationRegion (PCIM, SystemMemory, (\_SB.AGRB + (\_SB.PCI0.GPP0.PRBN << 0x14)), 0x0600)
            Field (PCIM, DWordAcc, NoLock, Preserve)
            {
                NVID,   16, 
                NDID,   16, 
                CMDR,   8, 
                VGAR,   2008, 
                Offset (0x48B), 
                    ,   1, 
                HDAE,   1
            }

            Method (_PS0, 0, NotSerialized)  // _PS0: Power State 0
            {
                _PSC = Zero
                If ((DGPS != Zero))
                {
                    \_SB.PCI0.GPP0.PG00._ON ()
                    DGPS = Zero
                }
            }

            Method (_PS3, 0, NotSerialized)  // _PS3: Power State 3
            {
                If ((OPCE == 0x03))
                {
                    If ((DGPS == Zero))
                    {
                        \_SB.PCI0.GPP0.PG00._OFF ()
                        DGPS = One
                    }

                    OPCE = 0x02
                }

                _PSC = 0x03
            }

            Method (SGST, 0, Serialized)
            {
                If ((PVID != 0xFFFF))
                {
                    Return (0x0F)
                }

                Return (Zero)
            }

            Method (CMPB, 2, NotSerialized)
            {
                Local1 = SizeOf (Arg0)
                If ((Local1 != SizeOf (Arg1)))
                {
                    Return (Zero)
                }

                Local0 = Zero
                While ((Local0 < Local1))
                {
                    If ((DerefOf (Arg0 [Local0]) != DerefOf (Arg1 [Local0]
                        )))
                    {
                        Return (Zero)
                    }

                    Local0++
                }

                Return (One)
            }

            Method (NVOP, 4, Serialized)
            {
                Debug = "------- NVOP --------"
                If ((Arg2 == Zero))
                {
                    Return (Buffer (0x04)
                    {
                         0x01, 0x00, 0x00, 0x04                           // ....
                    })
                }
                ElseIf ((Arg2 == 0x1A))
                {
                    Debug = "------- NVOP 0x1A --------"
                    CreateField (Arg3, 0x18, 0x02, OMPR)
                    CreateField (Arg3, Zero, One, FLCH)
                    CreateField (Arg3, One, One, DVSR)
                    CreateField (Arg3, 0x02, One, DVSC)
                    If (ToInteger (FLCH))
                    {
                        \_SB.PCI0.GPP0.PEGP.OPCE = OMPR /* \_SB_.PCI0.GPP0.PEGP.NVOP.OMPR */
                    }

                    Local0 = Buffer (0x04)
                        {
                             0x00, 0x00, 0x00, 0x00                           // ....
                        }
                    CreateField (Local0, Zero, One, OPEN)
                    CreateField (Local0, 0x03, 0x02, CGCS)
                    CreateField (Local0, 0x06, One, SHPC)
                    CreateField (Local0, 0x08, One, SNSR)
                    CreateField (Local0, 0x18, 0x03, DGPC)
                    CreateField (Local0, 0x1B, 0x02, HDAC)
                    OPEN = One
                    SHPC = One
                    HDAC = 0x03
                    DGPC = One
                    If (ToInteger (DVSC))
                    {
                        If (ToInteger (DVSR))
                        {
                            \_SB.PCI0.GPP0.PEGP.GPRF = One
                        }
                        Else
                        {
                            \_SB.PCI0.GPP0.PEGP.GPRF = Zero
                        }
                    }

                    SNSR = \_SB.PCI0.GPP0.PEGP.GPRF
                    If ((\_SB.PCI0.GPP0.PEGP.SGST () != Zero))
                    {
                        CGCS = 0x03
                    }

                    Return (Local0)
                }

                Return (0x80000002)
            }

            Method (NBCI, 4, Serialized)
            {
                Debug = "------- NBCI DSM --------"
                If ((Arg1 != 0x0102))
                {
                    Debug = " NBCI DSM: NOT SUPPORTED!"
                    Return (0x80000001)
                }

                Switch (ToInteger (Arg2))
                {
                    Case (Zero)
                    {
                        Return (Buffer (0x04)
                        {
                             0x01, 0x00, 0x01, 0x00                           // ....
                        })
                    }
                    Case (0x10)
                    {
                        Name (RTDR, Buffer (0xA1)
                        {
                            /* 0000 */  0x57, 0x74, 0xDC, 0x86, 0x75, 0x84, 0xEC, 0xE7,  // Wt..u...
                            /* 0008 */  0x52, 0x44, 0xA1, 0x00, 0x00, 0x00, 0x00, 0x01,  // RD......
                            /* 0010 */  0x00, 0x00, 0x00, 0x00, 0xDE, 0x10, 0x00, 0x00,  // ........
                            /* 0018 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                            /* 0020 */  0x09, 0x00, 0x00, 0x00, 0x00, 0x00, 0x34, 0x00,  // ......4.
                            /* 0028 */  0x00, 0x00, 0x01, 0x00, 0x47, 0x00, 0x00, 0x00,  // ....G...
                            /* 0030 */  0x02, 0x00, 0x45, 0x00, 0x00, 0x00, 0x03, 0x00,  // ..E.....
                            /* 0038 */  0x51, 0x00, 0x00, 0x00, 0x04, 0x00, 0x4F, 0x00,  // Q.....O.
                            /* 0040 */  0x00, 0x00, 0x05, 0x00, 0x4D, 0x00, 0x00, 0x00,  // ....M...
                            /* 0048 */  0x06, 0x00, 0x4B, 0x00, 0x00, 0x00, 0x07, 0x00,  // ..K.....
                            /* 0050 */  0x49, 0x00, 0x00, 0x00, 0x08, 0x00, 0x47, 0x00,  // I.....G.
                            /* 0058 */  0x00, 0x00, 0x01, 0x00, 0x00, 0x00, 0xD9, 0x1C,  // ........
                            /* 0060 */  0x04, 0x00, 0x00, 0x00, 0x02, 0x00, 0x00, 0x00,  // ........
                            /* 0068 */  0x41, 0x5D, 0xC9, 0x00, 0x01, 0x24, 0x2E, 0x00,  // A]...$..
                            /* 0070 */  0x02, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x01,  // ........
                            /* 0078 */  0x00, 0x00, 0x00, 0xD9, 0x1C, 0x04, 0x00, 0x00,  // ........
                            /* 0080 */  0x00, 0x01, 0x00, 0x00, 0x00, 0x60, 0x68, 0x9E,  // .....`h.
                            /* 0088 */  0x35, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // 5.......
                            /* 0090 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                            /* 0098 */  0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                            /* 00A0 */  0x00                                             // .
                        })
                        CreateWordField (Arg3, 0x02, USAG)
                        If ((USAG == 0x4452))
                        {
                            Debug = "------- NBCI RTDR --------"
                            Return (RTDR) /* \_SB_.PCI0.GPP0.PEGP.NBCI.RTDR */
                        }

                        Return (Zero)
                    }

                }

                Return (0x80000002)
            }

            Method (_DSM, 4, Serialized)  // _DSM: Device-Specific Method
            {
                CreateByteField (Arg0, 0x03, GUID)
                If (CMPB (Arg0, ToUUID ("a486d8f8-0bda-471b-a72b-6042a6b5bee0")))
                {
                    Return (\_SB.PCI0.GPP0.PEGP.NVOP (Arg0, Arg1, Arg2, Arg3))
                }
                ElseIf ((Arg0 == ToUUID ("d4a50b75-65c7-46f7-bfb7-41514cea0244")))
                {
                    Return (\_SB.PCI0.GPP0.PEGP.NBCI (Arg0, Arg1, Arg2, Arg3))
                }
                Else
                {
                    Return (0x80000002)
                }

                Return (0x80000001)
            }

            Method (_ROM, 2, NotSerialized)  // _ROM: Read-Only Memory
            {
                Local0 = Arg0
                Local1 = Arg1
                If ((Local1 > 0x1000))
                {
                    Local1 = 0x1000
                }

                If ((Local0 > 0x00030000))
                {
                    Return (Buffer (Local1)
                    {
                         0x00                                             // .
                    })
                }

                Local3 = (Local1 * 0x08)
                Name (ROM1, Buffer (0x3000)
                {
                     0x00                                             // .
                })
                Name (ROM2, Buffer (Local1)
                {
                     0x00                                             // .
                })
                If ((Local0 < 0x3000))
                {
                    ROM1 = M106 /* External reference */
                }
                ElseIf ((Local0 < 0x6000))
                {
                    Local0 -= 0x3000
                    ROM1 = M378 /* External reference */
                }
                ElseIf ((Local0 < 0x9000))
                {
                    Local0 -= 0x6000
                    ROM1 = M379 /* External reference */
                }
                ElseIf ((Local0 < 0xC000))
                {
                    Local0 -= 0x9000
                    ROM1 = M380 /* External reference */
                }
                ElseIf ((Local0 < 0xF000))
                {
                    Local0 -= 0xC000
                    ROM1 = M381 /* External reference */
                }
                ElseIf ((Local0 < 0x00012000))
                {
                    Local0 -= 0xF000
                    ROM1 = M382 /* External reference */
                }
                ElseIf ((Local0 < 0x00015000))
                {
                    Local0 -= 0x00012000
                    ROM1 = M383 /* External reference */
                }
                ElseIf ((Local0 < 0x00018000))
                {
                    Local0 -= 0x00015000
                    ROM1 = M384 /* External reference */
                }
                ElseIf ((Local0 < 0x0001B000))
                {
                    Local0 -= 0x00018000
                    ROM1 = M385 /* External reference */
                }
                ElseIf ((Local0 < 0x0001E000))
                {
                    Local0 -= 0x0001B000
                    ROM1 = M386 /* External reference */
                }
                ElseIf ((Local0 < 0x00021000))
                {
                    Local0 -= 0x0001E000
                    ROM1 = M387 /* External reference */
                }
                ElseIf ((Local0 < 0x00024000))
                {
                    Local0 -= 0x00021000
                    ROM1 = M388 /* External reference */
                }
                ElseIf ((Local0 < 0x00027000))
                {
                    Local0 -= 0x00024000
                    ROM1 = M389 /* External reference */
                }
                ElseIf ((Local0 < 0x0002A000))
                {
                    Local0 -= 0x00027000
                    ROM1 = M390 /* External reference */
                }
                ElseIf ((Local0 < 0x0002D000))
                {
                    Local0 -= 0x0002A000
                    ROM1 = M391 /* External reference */
                }
                ElseIf ((Local0 < 0x00030000))
                {
                    Local0 -= 0x0002D000
                    ROM1 = M392 /* External reference */
                }

                Local2 = (Local0 * 0x08)
                CreateField (ROM1, Local2, Local3, TMPB)
                ROM2 = TMPB /* \_SB_.PCI0.GPP0.PEGP._ROM.TMPB */
                Return (ROM2) /* \_SB_.PCI0.GPP0.PEGP._ROM.ROM2 */
            }
        }

        Method (NPLD, 2, Serialized)
        {
            Name (PCKG, Package (0x01)
            {
                Buffer (0x10)
                {
                    /* 0000 */  0x82, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  // ........
                    /* 0008 */  0x20, 0x1C, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00   //  .......
                }
            })
            CreateField (DerefOf (PCKG [Zero]), 0x40, One, VISI)
            VISI = Arg0
            CreateField (DerefOf (PCKG [Zero]), 0x57, 0x08, GPOS)
            GPOS = Arg1
            Return (PCKG) /* \_SB_.PCI0.GPP0.NPLD.PCKG */
        }

        Device (NHDA)
        {
            Name (_ADR, One)  // _ADR: Address
            Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
            {
                Return (Zero)
            }
        }

        Device (NXHC)
        {
            Name (_ADR, 0x02)  // _ADR: Address
            Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
            {
                Return (Zero)
            }

            Device (NHUB)
            {
                Name (_ADR, Zero)  // _ADR: Address
                Device (SS01)
                {
                    Name (_ADR, One)  // _ADR: Address
                    Method (_UPC, 0, Serialized)  // _UPC: USB Port Capabilities
                    {
                        Name (NUPC, Package (0x04)
                        {
                            Zero, 
                            0xFF, 
                            Zero, 
                            Zero
                        })
                        Return (NUPC) /* \_SB_.PCI0.GPP0.NXHC.NHUB.SS01._UPC.NUPC */
                    }

                    Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
                    {
                        Return (NPLD (Zero, One))
                    }
                }

                Device (SS02)
                {
                    Name (_ADR, 0x02)  // _ADR: Address
                    Method (_UPC, 0, Serialized)  // _UPC: USB Port Capabilities
                    {
                        Name (NUPC, Package (0x04)
                        {
                            Zero, 
                            0xFF, 
                            Zero, 
                            Zero
                        })
                        Return (NUPC) /* \_SB_.PCI0.GPP0.NXHC.NHUB.SS02._UPC.NUPC */
                    }

                    Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
                    {
                        Return (NPLD (Zero, 0x02))
                    }
                }

                Device (SS03)
                {
                    Name (_ADR, 0x03)  // _ADR: Address
                    Method (_UPC, 0, Serialized)  // _UPC: USB Port Capabilities
                    {
                        Name (NUPC, Package (0x04)
                        {
                            Zero, 
                            0xFF, 
                            Zero, 
                            Zero
                        })
                        Return (NUPC) /* \_SB_.PCI0.GPP0.NXHC.NHUB.SS03._UPC.NUPC */
                    }

                    Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
                    {
                        Return (NPLD (Zero, 0x03))
                    }
                }

                Device (SS04)
                {
                    Name (_ADR, 0x04)  // _ADR: Address
                    Method (_UPC, 0, Serialized)  // _UPC: USB Port Capabilities
                    {
                        Name (NUPC, Package (0x04)
                        {
                            Zero, 
                            0xFF, 
                            Zero, 
                            Zero
                        })
                        Return (NUPC) /* \_SB_.PCI0.GPP0.NXHC.NHUB.SS04._UPC.NUPC */
                    }

                    Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
                    {
                        Return (NPLD (Zero, 0x04))
                    }
                }

                Device (SS05)
                {
                    Name (_ADR, 0x05)  // _ADR: Address
                    Method (_UPC, 0, Serialized)  // _UPC: USB Port Capabilities
                    {
                        Name (NUPC, Package (0x04)
                        {
                            Zero, 
                            0xFF, 
                            Zero, 
                            Zero
                        })
                        Return (NUPC) /* \_SB_.PCI0.GPP0.NXHC.NHUB.SS05._UPC.NUPC */
                    }

                    Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
                    {
                        Return (NPLD (Zero, 0x05))
                    }
                }

                Device (SS06)
                {
                    Name (_ADR, 0x06)  // _ADR: Address
                    Method (_UPC, 0, Serialized)  // _UPC: USB Port Capabilities
                    {
                        Name (NUPC, Package (0x04)
                        {
                            Zero, 
                            0xFF, 
                            Zero, 
                            Zero
                        })
                        Return (NUPC) /* \_SB_.PCI0.GPP0.NXHC.NHUB.SS06._UPC.NUPC */
                    }

                    Method (_PLD, 0, NotSerialized)  // _PLD: Physical Location of Device
                    {
                        Return (NPLD (Zero, 0x06))
                    }
                }
            }
        }

        Device (NTPC)
        {
            Name (_ADR, 0x03)  // _ADR: Address
            Method (_RMV, 0, NotSerialized)  // _RMV: Removal Status
            {
                Return (Zero)
            }
        }

        Method (SGPC, 1, NotSerialized)
        {
            If ((Arg0 == One))
            {
                M000 (0x9D)
                Sleep (0x05)
                If ((M009 == PWOK))
                {
                    One
                    Return (Zero)
                }

                M010 (REST, Zero)
                Sleep (One)
                M010 (PWEN, One)
                Sleep (0x14)
                M010 (REST, One)
                Sleep (0x64)
                LNKD = Zero
                Sleep (One)
                Local6 = 0x7FFFFFFF
                Local6 |= 0x80000000
                0x08 = M017 (Zero, One, One, 0x19, Zero)
                Local2
                0x54 = M019 (Zero, One, One)
                Local1
                M020 (Zero, One, One, 0x54, (Local1 & 0xFFFF7FFC))
                Local4 = One
                Local5 = 0x28
                While ((Local4 && Local5))
                {
                     = M019 (Local2, Zero, Zero)
                    Local0
                    If ((Local0 != Local6))
                    {
                        Local4 = Zero
                    }
                    Else
                    {
                        Sleep (0x05)
                        Local5--
                    }
                }

                \_SB.PCI0.GPP0.LREN = \_SB.PCI0.GPP0.PEGP.LTRE
                \_SB.PCI0.GPP0.CEDR = One
                M020 (Zero, One, One, 0x54, (Local1 & 0xFFFF7FFF))
                M000 (0xA0)
            }
            Else
            {
                M000 (0xA1)
                M010 (PWEN, One)
                \_SB.PCI0.GPP0.PEGP.LTRE = \_SB.PCI0.GPP0.LREN
                LNKD = One
                M010 (REST, Zero)
                Sleep (One)
                M010 (PWEN, Zero)
                Sleep (0x64)
                M000 (0xA3)
            }
        }
    }

    Scope (\_SB.PCI0.GPP0.SWUS)
    {
        PowerResource (PG00, 0x00, 0x0000)
        {
            Name (M239, One)
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                Return (M239) /* \_SB_.PCI0.GPP0.SWUS.PG00.M239 */
            }

            Method (_ON, 0, NotSerialized)  // _ON_: Power On
            {
                M239 = One
            }

            Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
            {
                M239 = Zero
            }
        }

        Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
        {
            PG00
        })
        Name (_PR2, Package (0x01)  // _PR2: Power Resources for D2
        {
            PG00
        })
        Name (_PR3, Package (0x01)  // _PR3: Power Resources for D3hot
        {
            PG00
        })
        Name (_S0W, 0x04)  // _S0W: S0 Device Wake State
    }

    Scope (\_SB.PCI0.GPP0.SWUS.SWDS)
    {
        PowerResource (PG00, 0x00, 0x0000)
        {
            Name (M239, One)
            Method (_STA, 0, NotSerialized)  // _STA: Status
            {
                Return (M239) /* \_SB_.PCI0.GPP0.SWUS.SWDS.PG00.M239 */
            }

            Method (_ON, 0, NotSerialized)  // _ON_: Power On
            {
                M239 = One
            }

            Method (_OFF, 0, NotSerialized)  // _OFF: Power Off
            {
                M239 = Zero
            }
        }

        Name (_PR0, Package (0x01)  // _PR0: Power Resources for D0
        {
            PG00
        })
        Name (_PR2, Package (0x01)  // _PR2: Power Resources for D2
        {
            PG00
        })
        Name (_PR3, Package (0x01)  // _PR3: Power Resources for D3hot
        {
            PG00
        })
        Name (_S0W, 0x04)  // _S0W: S0 Device Wake State
    }
}

