/*
 * Intel ACPI Component Architecture
 * AML/ASL+ Disassembler version 20190509 (64-bit version)
 * Copyright (c) 2000 - 2019 Intel Corporation
 * 
 * Disassembling to symbolic ASL+ operators
 *
 * Disassembly of ssdt7.dat, Sun Jan 26 18:45:00 2020
 *
 * Original Table Header:
 *     Signature        "SSDT"
 *     Length           0x000002AA (682)
 *     Revision         0x01
 *     Checksum         0xFE
 *     OEM ID           "AMD"
 *     OEM Table ID     "AmdTable"
 *     OEM Revision     0x00000001 (1)
 *     Compiler ID      "INTL"
 *     Compiler Version 0x20120913 (538052883)
 */
DefinitionBlock ("", "SSDT", 1, "AMD", "AmdTable", 0x00000001)
{
    /*
     * iASL Warning: There were 5 external control methods found during
     * disassembly, but only 0 were resolved (5 unresolved). Additional
     * ACPI tables may be required to properly disassemble the code. This
     * resulting disassembler output file may not compile because the
     * disassembler did not know how many arguments to assign to the
     * unresolved methods. Note: SSDTs can be dynamically loaded at
     * runtime and may or may not be available via the host OS.
     *
     * To specify the tables needed to resolve external control method
     * references, the -e option can be used to specify the filenames.
     * Example iASL invocations:
     *     iasl -e ssdt1.aml ssdt2.aml ssdt3.aml -d dsdt.aml
     *     iasl -e dsdt.aml ssdt2.aml -d ssdt1.aml
     *     iasl -e ssdt*.aml -d dsdt.aml
     *
     * In addition, the -fe option can be used to specify a file containing
     * control method external declarations with the associated method
     * argument counts. Each line of the file must be of the form:
     *     External (<method pathname>, MethodObj, <argument count>)
     * Invocation:
     *     iasl -fe refs.txt -d dsdt.aml
     *
     * The following methods were unresolved and many not compile properly
     * because the disassembler had to guess at the number of arguments
     * required for each:
     */
    External (_SB_.PCI0.GP17.ACP_, DeviceObj)
    External (_SB_.PCI0.GP17.AZAL, DeviceObj)
    External (M000, MethodObj)    // Warning: Unknown method, guessing 1 arguments
    External (M017, MethodObj)    // Warning: Unknown method, guessing 5 arguments
    External (M019, MethodObj)    // Warning: Unknown method, guessing 3 arguments
    External (M249, MethodObj)    // Warning: Unknown method, guessing 2 arguments
    External (M250, MethodObj)    // Warning: Unknown method, guessing 4 arguments

    Name (M278, One)
    Name (M279, One)
    Method (M276, 0, NotSerialized)
    {
        If (((M278 == One) || (M279 == One)))
        {
            0x08 = M017 (Zero, 0x08, One, 0x19, Zero)
            Local0
             = M019 (Local0, Zero, 0x05)
            Local1
            If (((Local0 != Zero) && (Local0 != 0xFF)))
            {
                If ((Local1 != Ones))
                {
                    M000 (0xB4)
                    M250 (Zero, Zero, 0x00058A74, Zero)
                    M250 (Zero, Zero, 0x00058A54, 0xC8)
                    M250 (Zero, Zero, 0x00058A14, 0x03)
                    0x00058A74 = M249 (Zero, Zero)
                    Local4
                    While ((Local4 == Zero))
                    {
                        0x00058A74 = M249 (Zero, Zero)
                        Local4
                        If ((Local4 != Zero))
                        {
                            Break
                        }
                    }

                    M250 (Zero, Zero, 0x00048720, 0x0103)
                    Local4 = One
                    Local5 = 0x64
                    While (((Local4 != Zero) && Local5))
                    {
                        0x00048720 = M249 (Zero, Zero)
                        Local4
                        Local4 |= 0x06
                        Local4 &= 0xFFFFFF0F
                        M250 (Zero, Zero, 0x00048720, Local4)
                        0x00048728 = M249 (Zero, Zero)
                        Local4
                        Local4 &= 0x03
                        Local5--
                        Stall (0x63)
                    }

                    M250 (Zero, Zero, 0x00048720, Zero)
                    M000 (0xB5)
                }
            }
        }
    }

    Method (M277, 0, NotSerialized)
    {
        If (((M278 == Zero) && (M279 == Zero)))
        {
            0x08 = M017 (Zero, 0x08, One, 0x19, Zero)
            Local0
             = M019 (Local0, Zero, 0x05)
            Local1
            If (((Local0 != Zero) && (Local0 != 0xFF)))
            {
                If ((Local1 != Ones))
                {
                    M000 (0xB6)
                    M250 (Zero, Zero, 0x00058A74, Zero)
                    M250 (Zero, Zero, 0x00058A54, Zero)
                    M250 (Zero, Zero, 0x00058A14, 0x03)
                    0x00058A74 = M249 (Zero, Zero)
                    Local4
                    While ((Local4 == Zero))
                    {
                        0x00058A74 = M249 (Zero, Zero)
                        Local4
                        If ((Local4 != Zero))
                        {
                            Break
                        }
                    }

                    M250 (Zero, Zero, 0x00048720, 0x0101)
                    Local4 = One
                    Local5 = 0x64
                    While (((Local4 != 0x02) && Local5))
                    {
                        0x00048720 = M249 (Zero, Zero)
                        Local4
                        Local4 |= 0x06
                        Local4 &= 0xFFFFFF0F
                        M250 (Zero, Zero, 0x00048720, Local4)
                        0x00048728 = M249 (Zero, Zero)
                        Local4
                        Local4 &= 0x03
                        Local5--
                        Stall (0x63)
                    }

                    M250 (Zero, Zero, 0x00048720, Zero)
                    M000 (0xB7)
                }
            }
        }
    }

    Scope (\_SB.PCI0.GP17.ACP)
    {
        Method (_PS0, 0, NotSerialized)  // _PS0: Power State 0
        {
            M278 = One
            M276 ()
        }

        Method (_PS3, 0, NotSerialized)  // _PS3: Power State 3
        {
            M278 = Zero
            M277 ()
        }
    }

    Scope (\_SB.PCI0.GP17.AZAL)
    {
        Method (_PS0, 0, NotSerialized)  // _PS0: Power State 0
        {
            M279 = One
            M276 ()
        }

        Method (_PS3, 0, NotSerialized)  // _PS3: Power State 3
        {
            M279 = Zero
            M277 ()
        }
    }
}

